accounting/apps/reports/urls.py
from django.conf.urls import patterns, url

from . import views


urlpatterns = patterns('',

    # Reports
    url(r'^report/$',
        views.ReportListView.as_view(),
        name="report-list"),
    url(r'^report/tax/$',
        views.TaxReportView.as_view(),
        name="tax-report"),
    url(r'^report/profitloss/$',
        views.ProfitAndLossReportView.as_view(),
        name="profit-and-loss-report"),
    url(r'^report/payrun/$',
        views.PayRunReportView.as_view(),
        name="pay-run-report"),
    url(r'^report/invoicedetails/$',
        views.InvoiceDetailsView.as_view(),
        name="invoice-details-report"),

    # Settings
    url(r'^settings/$',
        views.SettingsListView.as_view(),
        name="settings-list"),
    url(r'^settings/business/$',
        views.BusinessSettingsUpdateView.as_view(),
        name="settings-business"),
    url(r'^settings/financial/$',
        views.FinancialSettingsUpdateView.as_view(),
        name="settings-financial"),
    url(r'^settings/payrun/$',
        views.PayRunSettingsUpdateView.as_view(),
        name="settings-payrun"),
)

accounting/urls.py
from django.conf import settings
from django.conf.urls import patterns, include, url
from django.conf.urls.static import static


urlpatterns = patterns('',
    url(r'^', include('accounting.apps.connect.urls',
        namespace="connect")),
    url(r'^books/', include('accounting.apps.books.urls',
        namespace="books")),
    url(r'^people/', include('accounting.apps.people.urls',
        namespace="people")),
    url(r'^reports/', include('accounting.apps.reports.urls',
        namespace="reports")),

    # third party
    url(r'^select2/', include('django_select2.urls')),
)

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)

accounting/apps/reports/models.py
from django.db import models
from django.core.validators import MinValueValidator, MaxValueValidator


class BusinessSettings(models.Model):
    BUSINESS_TYPE_SOLE_PROPRIETORSHIP = 'sole_proprietorship'
    BUSINESS_TYPE_PARTNERSHIP = 'partnership'
    BUSINESS_TYPE_CORPORATION = 'corporation'
    BUSINESS_TYPE_CHOICES = (
        (BUSINESS_TYPE_SOLE_PROPRIETORSHIP, "Sole Proprietorship"),
        (BUSINESS_TYPE_PARTNERSHIP, "Partnership"),
        (BUSINESS_TYPE_CORPORATION, "Corporation"),
    )
    business_type = models.CharField(max_length=50,
                                     choices=BUSINESS_TYPE_CHOICES)

    # optionnaly linked to an organization
    # for automated behaviors during cross-organizations invoicing
    organization = models.OneToOneField('books.Organization',
                                        related_name="business_settings",
                                        blank=True, null=True)

    class Meta:
        pass


class FinancialSettings(models.Model):
    financial_year_end_day = models.PositiveSmallIntegerField(default=31,
        validators=[
            MinValueValidator(1),
            MaxValueValidator(31)
        ])
    financial_year_end_month = models.PositiveSmallIntegerField(default=12,
        validators=[
            MinValueValidator(1),
            MaxValueValidator(12)
        ])

    tax_id_number = models.CharField(max_length=150,
                                     blank=True, null=True)
    tax_id_display_name = models.CharField(max_length=150,
                                           blank=True, null=True)

    TAX_PERIOD_MONTHLY = 'monthly'      # 1 month
    TAX_PERIOD_BIMONTHLY = 'bimonthly'  # 2 months
    TAX_PERIOD_QUARTER = 'quarter'      # 3 months
    TAX_PERIOD_HALF = 'half'            # 6 months
    TAX_PERIOD_YEAR = 'year'            # 12 months
    TAX_PERIOD_CHOICES = (
        (TAX_PERIOD_MONTHLY, "1 month"),
        (TAX_PERIOD_BIMONTHLY, "2 months"),
        (TAX_PERIOD_QUARTER, "3 months"),
        (TAX_PERIOD_HALF, "6 months"),
        (TAX_PERIOD_YEAR, "1 year"),
    )
    tax_period = models.CharField("Tax Period",
                                  max_length=20,
                                  choices=TAX_PERIOD_CHOICES)

    # optionnaly linked to an organization
    # for automated behaviors during cross-organizations invoicing
    organization = models.OneToOneField('books.Organization',
                                        related_name="financial_settings",
                                        blank=True, null=True)

    class Meta:
        pass


class PayRunSettings(models.Model):
    salaries_follow_profits = models.BooleanField(default=False)

    PAYRUN_MONTHLY = 'monthly'      # 1 month
    # PAYRUN_QUARTER = 'quarter'      # 3 months
    PAYRUN_CHOICES = (
        (PAYRUN_MONTHLY, "monthly"),
    )
    payrun_period = models.CharField("Payrun Period",
                                     max_length=20,
                                     choices=PAYRUN_CHOICES,
                                     default=PAYRUN_MONTHLY)

    # optionnaly linked to an organization
    # for automated behaviors during cross-organizations invoicing
    organization = models.OneToOneField('books.Organization',
                                        related_name="payrun_settings",
                                        blank=True, null=True)

    class Meta:
        pass

accounting/apps/reports/forms.py
from datetime import timedelta

from django import forms

from .models import (
    BusinessSettings,
    FinancialSettings,
    PayRunSettings)


class BusinessSettingsForm(forms.ModelForm):
    class Meta:
        model = BusinessSettings
        fields = (
            "business_type",
        )


class FinancialSettingsForm(forms.ModelForm):
    class Meta:
        model = FinancialSettings
        fields = (
            "financial_year_end_day",
            "financial_year_end_month",

            "tax_id_number",
            "tax_id_display_name",
            "tax_period",
        )


class PayRunSettingsForm(forms.ModelForm):
    class Meta:
        model = PayRunSettings
        fields = (
            "salaries_follow_profits",
            "payrun_period",
        )


class TimePeriodForm(forms.Form):
    date_from = forms.DateField(required=False,
                                label="From")
    date_to = forms.DateField(required=False,
                              label="To")

    _filters = None
    _description = None

    def _determine_filter_metadata(self):
        self._filters = {}
        self._description = "All orders"
        if self.errors:
            return

        date_from = self.cleaned_data['date_from']
        date_to = self.cleaned_data['date_to']
        if date_from and date_to:
            # We want to include end date so we adjust the date we
            # use with the 'range' function.
            self._filters = {
                'date_placed__range': [
                    date_from,
                    date_to + timedelta(days=1)
                ]
            }
            self._description = ("Between {} and {}"
                .format(date_from, date_to))
        elif date_from and not date_to:
            self._filters = {'date_placed__gte': date_from}
            self._description = "Since {}".format(date_from)
        elif not date_from and date_to:
            self._filters = {'date_placed__lte': date_to}
            self._description = "Until {}".format(date_to)
        else:
            self._filters = {}
            self._description = "From the begining to now"

    def get_filters(self):
        if self._filters is None:
            self._determine_filter_metadata()
        return self._filters

    def get_filter_description(self):
        if self._description is None:
            self._determine_filter_metadata()
        return self._description

accounting/apps/reports/views.py
from datetime import date

from django.views import generic
from django.core.urlresolvers import reverse
from django.utils import timezone

from dateutil.relativedelta import relativedelta

from accounting.apps.books.utils import organization_manager
from accounting.libs.intervals import TimeInterval
from .models import (
    BusinessSettings,
    FinancialSettings,
    PayRunSettings)
from .forms import (
    BusinessSettingsForm,
    FinancialSettingsForm,
    PayRunSettingsForm,
    TimePeriodForm)
from .wrappers import (
    TaxReport,
    ProfitAndLossReport,
    PayRunReport,
    InvoiceDetailsReport)


class TimePeriodFormMixin(object):

    period = None

    def get_initial(self):
        initial = super().get_initial()

        # currrent quarter
        now = timezone.now()
        start = date(
            year=now.year,
            month=(now.month - ((now.month - 1) % 3)),
            day=1
        )
        end = start + relativedelta(months=3)

        initial['date_from'] = start
        initial['date_to'] = end

        return initial

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        if self.request.GET:
            kwargs.update({
                'data': self.request.GET,
            })
        return kwargs

    def get_context_data(self, **kwargs):
        ctx = super().get_context_data(**kwargs)

        form = ctx['form']
        if form.is_valid():
            start = form.cleaned_data['date_from']
            end = form.cleaned_data['date_to']
            ctx['form_title'] = form.get_filter_description()
        else:
            start = end = None
            ctx['form_title'] = "Time Interval"

        if self.period is None:
            self.period = TimeInterval(start=start, end=end)

        return ctx


class ReportListView(generic.TemplateView):
    template_name = "reports/report_list.html"


class SettingsListView(generic.TemplateView):
    template_name = "reports/settings_list.html"


class GenericSettingsMixin(object):

    def get_object(self):
        orga = organization_manager.get_selected_organization(self.request)
        try:
            settings = self.model.objects.get(organization=orga)
        except self.model.DoesNotExist:
            settings = self.model.objects.create(organization=orga)
        return settings

    def get_success_url(self):
        return reverse("reports:settings-list")


class BusinessSettingsUpdateView(GenericSettingsMixin,
                                 generic.UpdateView):
    template_name = "reports/financial_settings_update.html"
    model = BusinessSettings
    form_class = BusinessSettingsForm


class FinancialSettingsUpdateView(GenericSettingsMixin,
                                  generic.UpdateView):
    template_name = "reports/financial_settings_update.html"
    model = FinancialSettings
    form_class = FinancialSettingsForm


class PayRunSettingsUpdateView(GenericSettingsMixin,
                               generic.UpdateView):
    template_name = "reports/payrun_settings_update.html"
    model = PayRunSettings
    form_class = PayRunSettingsForm


class TaxReportView(TimePeriodFormMixin,
                    generic.FormView):
    template_name = "reports/tax_report.html"
    form_class = TimePeriodForm

    def get_context_data(self, **kwargs):
        ctx = super().get_context_data(**kwargs)
        orga = organization_manager.get_selected_organization(self.request)
        report = TaxReport(orga,
                           start=self.period.start,
                           end=self.period.end)
        report.generate()
        ctx['tax_summaries'] = report.tax_summaries.values()
        return ctx


class ProfitAndLossReportView(generic.TemplateView):
    template_name = "reports/profit_and_loss_report.html"

    def get_context_data(self, **kwargs):
        ctx = super().get_context_data(**kwargs)
        orga = organization_manager.get_selected_organization(self.request)

        # currrent quarter
        now = timezone.now()
        start = date(
            year=now.year,
            month=(now.month - ((now.month - 1) % 3)),
            day=1
        )
        end = start + relativedelta(months=3)

        report = ProfitAndLossReport(orga, start=start, end=end)
        report.generate()
        ctx['summaries'] = report.summaries
        ctx['total_summary'] = report.total_summary
        return ctx


class PayRunReportView(TimePeriodFormMixin,
                       generic.FormView):
    template_name = "reports/pay_run_report.html"
    form_class = TimePeriodForm

    def get_context_data(self, **kwargs):
        ctx = super().get_context_data(**kwargs)
        orga = organization_manager.get_selected_organization(self.request)

        report = PayRunReport(orga,
                              start=self.period.start,
                              end=self.period.end)
        report.generate()
        ctx['summaries'] = report.summaries.values()
        ctx['total_payroll_taxes'] = report.total_payroll_taxes

        return ctx


class InvoiceDetailsView(TimePeriodFormMixin,
                         generic.FormView):
    template_name = "reports/invoice_details_report.html"
    form_class = TimePeriodForm

    def get_context_data(self, **kwargs):
        ctx = super().get_context_data(**kwargs)
        orga = organization_manager.get_selected_organization(self.request)
        report = InvoiceDetailsReport(orga,
                                      start=self.period.start,
                                      end=self.period.end)
        report.generate()
        ctx['invoices'] = report.invoices
        ctx['tax_rates'] = report.tax_rates
        ctx['payrun_settings'] = orga.payrun_settings
        return ctx

accounting/templates/accounting/reports/financial_settings_update.html
{% extends "_generics/form.html" %}

accounting/templates/accounting/reports/invoice_details_report.html
{% extends "accounting/layout.html" %}
{% load currency_filters bootstrap3 %}

{% block content %}
    <h1 class="page-header">Invoice Details</h1>

    <div class="panel panel-default">
        <div class="panel-heading">
            <h3 class="panel-title">{{ form_title }}</h3>
        </div>
        <div class="panel-body">
            <form action="." method="get">
                {% bootstrap_form_errors form %}

                <div class="row">
                    <div class="col-md-5">
                        {% bootstrap_field form.date_from show_label=False %}
                    </div>
                    <div class="col-md-5">
                        {% bootstrap_field form.date_to show_label=False %}
                    </div>
                    <div class="col-md-2">
                        <button class="btn btn-info" type="submit">
                            Update
                        </button>
                    </div>
                </div>
            </form>
        </div>
    </div>

    <hr>

    <table class="table">
        <thead>
            <tr>
                <th>Invoice #</th>
                <th>Issue Date</th>
                <th>Status</th>
                <th>Item</th>
                <th>Unit Cost</th>
                <th>Quantity</th>
                {% for t in tax_rates %}
                <th>{{ t.name }}</th>
                {% endfor %}
                <th>Amount</th>
            </tr>
        </thead>
        <tbody>
        {% for inv in invoices %}
            <tr>
                <td>{{ inv.number }}</td>
                <td>{{ inv.date_issued }}</td>
                <td>{{ inv.status }}</td>
            {% for line in inv.lines.all %}
                <td>{{ line.label }}</td>
                <td>{{ line.unit_price.excl_tax }}</td>
                <td>{{ line.quantity }}</td>
                {% for t in tax_rates %}
                {% if t.pk == line.tax_rate_id %}
                <td>{{ line.taxes }}</td>
                {% else %}
                <td>-</td>
                {% endif %}
                {% endfor %}
                <td>{{ line.line_price_excl_tax|currency }}</td>
            {% if not forloop.last %}
            <tr>
                <td colspan=3></td>
            {% endif %}
            {% endfor %}
            </tr>
            <tr>
                <td colspan={{ tax_rates|length|add:"5" }}></td>
                <td class="text-right">Subtotal</td>
                <td>{{ inv.total_excl_tax|currency }}</td>
            </tr>
            <tr>
                <td colspan={{ tax_rates|length|add:"5" }} class="empty-cell"></td>
                <td class="text-right">Taxes</td>
                <td>{{ inv.total_tax|currency }}</td>
            </tr>
            <tr>
                <td colspan={{ tax_rates|length|add:"5" }} class="empty-cell"></td>
                <td class="text-right"><strong>Total</strong></td>
                <td><strong>{{ inv.total_incl_tax|currency }}</strong></td>
            </tr>
            <tr>
                <td colspan={{ tax_rates|length|add:"5" }} class="empty-cell"></td>
                <td class="text-right">Paid</td>
                <td>{{ inv.total_paid|currency }}</td>
            </tr>
            <tr>
                <td colspan={{ tax_rates|length|add:"5" }} class="empty-cell"></td>
                <td class="text-right"><strong>Balance</strong></td>
                <td><strong>{{ inv.total_due_incl_tax|currency }}</strong></td>
            </tr>
            {% if payrun_settings.salaries_follow_profits %}
            <tr>
                <td colspan={{ tax_rates|length|add:"5" }} class="empty-cell"></td>
                <td class="text-right">Payroll taxes</td>
                <td>{{ inv.payroll_taxes|currency }}</td>
            </tr>
            {% endif %}
            <tr class="empty-line"><td></td></tr>
        {% if not forloop.last %}
        </tbody>
        <tbody>
        {% endif %}
        {% endfor %}
        </tbody>
    </table>
{% endblock content %}

accounting/templates/accounting/reports/pay_run_report.html
{% extends "accounting/layout.html" %}
{% load currency_filters format_filters bootstrap3 %}

{% block content %}
    <h1 class="page-header">Pay Run Report <small>don't spend that money neither</small></h1>

    <div class="panel panel-default">
        <div class="panel-heading">
            <h3 class="panel-title">{{ form_title }}</h3>
        </div>
        <div class="panel-body">
            {% include "accounting/reports/_partials/period_form.html" with form=form %}
        </div>
    </div>

    <hr>

    <table class="table table-striped table-bordered">
        <thead>
            <tr>
                <th>Employee</th>
                <th>Gross pay</th>
                <th>Payroll Tax Rate</th>
                <th class="text-right">Payroll Taxes</th>
            </tr>
        </thead>
        <tbody>
            {% for summary in summaries %}
            <tr>
                <td><strong>{{ summary.employee }}</strong></td>
                <td>{{ summary.total_excl_tax|currency }}</td>
                <td>{{ summary.payroll_tax_rate|percentage }}</td>
                <td class="text-right">{{ summary.payroll_taxes|currency }}</td>
            <tr>
            {% endfor %}
        </tbody>
    </table>

    <div class="row text-right">
        <div class="col-xs-2 col-xs-offset-8">
            <p>
                <strong>
                    Total Taxes : <br>
                </strong>
            </p>
        </div>
        <div class="col-xs-2">
            <strong>
                {{ total_payroll_taxes|currency }} <br>
            </strong>
        </div>
    </div>
{% endblock content %}

accounting/templates/accounting/reports/payrun_settings_update.html
{% extends "_generics/form.html" %}

accounting/templates/accounting/reports/profit_and_loss_report.html
{% extends "accounting/layout.html" %}
{% load currency_filters %}

{% block content %}
    <h1 class="page-header">Profit and Loss <small>how ur doin'?</small></h1>

    <table class="table">
        <thead>
            <tr>
                <th></th>
                {% for key_date in summaries.keys %}
                <th class="text-right">{{ key_date|date:"b" }}</th>
                {% endfor %}
                <th class="text-right">Total</th>
            </tr>
        </thead>
        <tbody>
            <tr class="empty-line"><td></td></tr>
            <tr>
                <td colspan="{{ summaries.keys|length|add:'2' }}"><strong>Income</strong></td>
            </tr>
            <tr class="text-right">
                <td></td>
                {% for summary in summaries.values %}
                <td>{{ summary.sales_amount|currency }}</td>
                {% endfor %}
                <td>{{ total_summary.sales_amount|currency }}</td>
            </tr>
        </tbody>
        <tbody>
            <tr class="empty-line"><td></td></tr>
            <tr>
                <td colspan="{{ summaries.keys|length|add:'2' }}"><strong>Expenses</strong></td>
            </tr>
            <tr class="text-right">
                <td></td>
                {% for summary in summaries.values %}
                <td>{{ summary.expenses_amount|currency }}</td>
                {% endfor %}
                <td>{{ total_summary.expenses_amount|currency }}</td>
            </tr>
        </tbody>
        <tbody>
            <tr class="empty-line"><td></td></tr>
            <tr>
                <td colspan="{{ summaries.keys|length|add:'2' }}"><strong>Net Profit</strong></td>
            </tr>
            <tr class="text-right">
                <td></td>
                {% for summary in summaries.values %}
                <td>{{ summary.net_profit|currency }}</td>
                {% endfor %}
                <td>{{ total_summary.net_profit|currency }}</td>
            </tr>
        </tbody>
    </table>
{% endblock content %}

accounting/templates/accounting/reports/report_list.html
{% extends "accounting/layout.html" %}

{% block content %}
    <h1 class="page-header">Reports <small>which belong to you</small></h1>

    <div class="panel panel-default panel-link">
        <div class="panel-heading">
            <a href="{% url 'reports:tax-report' %}"><h3 class="panel-title">Tax Report</h3></a>
        </div>
        <div class="panel-body">
            Prepare the tax report for your tax period (defined in the <a href="{% url 'reports:settings-financial' %}">financial settings</a>)
        </div>
    </div>

    <div class="panel panel-default panel-link">
        <div class="panel-heading">
            <a href="{% url 'reports:profit-and-loss-report' %}"><h3 class="panel-title">Profit and Loss</h3></a>
        </div>
        <div class="panel-body">
            Know how your business is doing
        </div>
    </div>

    <div class="panel panel-default panel-link">
        <div class="panel-heading">
            <a href="{% url 'reports:pay-run-report' %}"><h3 class="panel-title">Pay run</h3></a>
        </div>
        <div class="panel-body">
            How much payroll you should keep
        </div>
    </div>

    <div class="panel panel-default panel-link">
        <div class="panel-heading">
            <a href="{% url 'reports:invoice-details-report' %}"><h3 class="panel-title">Invoice details</h3></a>
        </div>
        <div class="panel-body">
            How much payroll you should keep
        </div>
    </div>
{% endblock content %}

accounting/templates/accounting/reports/settings_list.html
{% extends "accounting/layout.html" %}

{% block content %}
    <h1 class="page-header">Settings <small>for powerful reports</small></h1>

    <a href="{% url 'reports:settings-business' %}" class="panel panel-default panel-link">
        <div class="panel-body">
            Business settings
        </div>
    </a>

    <a href="{% url 'reports:settings-financial' %}" class="panel panel-default panel-link">
        <div class="panel-body">
            Financial settings
        </div>
    </a>

    <a href="{% url 'reports:settings-payrun' %}" class="panel panel-default panel-link">
        <div class="panel-body">
            Payrun settings
        </div>
    </a>
{% endblock content %}

accounting/templates/accounting/reports/tax_report.html
{% extends "accounting/layout.html" %}
{% load currency_filters %}

{% block content %}
    <h1 class="page-header">Tax Report <small>don't spend that money</small></h1>

    <div class="panel panel-default">
        <div class="panel-heading">
            <h3 class="panel-title">{{ form_title }}</h3>
        </div>
        <div class="panel-body">
            {% include "accounting/reports/_partials/period_form.html" with form=form %}
        </div>
    </div>

    <hr>

    <table class="table">
        <thead>
            <tr>
                <th>Tax Name</th>
                <th>Taxable Amount</th>
                <th>Taxes</th>
            </tr>
        </thead>
        {% for summary in tax_summaries %}
        <tbody>
            <tr class="empty-line"><td></td></tr>
            <tr>
                <td><strong>{{ summary.tax_rate }}</strong></td>
                <td></td>
                <td></td>
            <tr>
                <td>
                    <abbr href="#" data-toggle="tooltip" data-placement="top" title="The amount includes fully or partially paid invoices">
                        Collected
                    </abbr>
                </td>
                <td>{{ summary.taxable_amount|currency }}</td>
                <td>{{ summary.collected_taxes|currency }}</td>
            </tr>
            <tr>
                <td>Expenses</td>
                <td>{{ summary.expenses_amount|currency }}</td>
                <td>{{ summary.deductible_taxes|currency }}</td>
            </tr>
            <tr>
                <td>NET</td>
                <td>{{ summary.net_amount|currency }}</td>
                <td>{{ summary.net_taxes|currency }}</td>
            </tr>
        </tbody>
        {% endfor %}
    </table>
{% endblock content %}